##
## Copyright (C) 2017 Lenovo, Inc.
## Licensed under the Apache License, Version 2.0 (the "License"); 
## you may not use this file except in compliance with the License. 
## You may obtain a copy of the License at 
##       http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software 
## distributed under the License is distributed on an "AS IS" BASIS, 
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and 
## limitations under the License.
##
require 'rest-client'
require 'json'
require_relative 'connect'
require_relative 'rest_utils'


##
## The Lacp class provides a class implementation and methods for managing Lacp 
## on the node. This class presents an abstraction
## 

class Lacp
	@@cfg  = '/nos/api/cfg/lacp'
	# This API gets the LACP properties of the system.
        # 
        # 
        #  parameters:
        #  conn - connection object to the node
        #
        #  return: JSON response 		
        def self.get_lacp(conn)
                url = form_url(conn, @@cfg)
                hdr = form_hdr(conn)
		Rest.get(conn, url ,hdr)
        end
	
	# This API updates the LACP properties of the system.
        # 
        # 
        #  parameters:
        #  conn - connection object to the node
        #  sys_prio - System Priority
        #  params - dictionary that requires the following format of key-value pairs
        #  	    {	
        #  	    	  "sys_prio": "<sys_prio>",
        #  	    }
        #  description -
        #  sys_prio   :LACP system priority; a positive integer from 1‐65535. Default
        #  	       value: 32768.
        #
        #  return: JSON response	       
	def self.update_lacp(conn, params)
                url = form_url(conn, @@cfg)
                hdr = form_hdr(conn)
		params = params.to_json
		Rest.put(conn, url, hdr, params)

        end

end
